package net.rmi.utils;

import classUtils.putils.ClassPathUtils;
import gui.In;

import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;

import utils.SystemUtils;

public class Compile {
    public static void rmic() {
        String
                fn = "rmi.rmiimage.Server";
        rmic(fn);
    }

    public static void startWebStart() {
        String args[] = {
            "C:\\Program Files\\Java Web Start\\javaws.exe",
            "http://show.docjava.com:8086/book/cgij/code/jnlp/dhry.Main.jnlp"
        };
        try {
            runExec(args, new File("c:\\lyon\\j4p\\classes"));
            boolean kill = In.promptYesNo("kill the dhrystone?");
            //p.destroy();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void main(String args[]) {
        rmicTestDos2();
        //startWebStart();
    }

    private static void rmicTestDos() {
        Runtime rt = Runtime.getRuntime();
        String args1[] = {
            "C:\\j2sdk1.4.1_02\\bin\\rmic",
            "-v1.2 -classpath", "c:\\lyon\\j4p\\classes",
            "d", "c:\\lyon\\j4p\\classes",
            "net.rmi.armi.RemoteHelloImplementation"
        };
        String args[] = {
            "dir"
        };
        try {
            Process p = rt.exec(args, null, new File("c:\\lyon\\j4p\\classes"));
            BufferedReader br
                    = new BufferedReader(new InputStreamReader(p.getErrorStream()));
            String s = null;
            while ((s = br.readLine()) != null)
                System.out.println("dos:" + s);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static String getRmicLocation() {
        // return "C:\\j2sdk1.4.1_02\\bin\\rmic";
        return utils.SystemUtils.getRmicPath();
    }

    // For homework, automate the computation of
    // the following variables:
    /*
        File workingDirectory = new File("c:\\lyon\\j4p\\classes");
        String className = "net.rmi.armi.RemoteHelloImplementation";
        String destinationDirectory = "c:\\lyon\\j4p\\classes\\net\\rmi\\armi\\";
        String classPath = "c:\\lyon\\j4p\\classes\\";
    */
    private static void rmicTestDos2() {
        File workingDirectory = new File("c:\\lyon\\j4p\\classes");

        String className = "net.rmi.armi.RemoteHelloImplementation";
        String destinationDirectory = "c:\\lyon\\j4p\\classes\\net\\rmi\\armi\\";
        String classPath = "c:\\lyon\\j4p\\classes\\";
        runRmic(classPath, destinationDirectory, workingDirectory, className);
    }

    public static void runRmic(String classPath,
                               String destinationDirectory,
                               File workingDirectory,
                               String className) {
        String args[] = {
            getRmicLocation(),
            "-v1.2",
            "-classpath", classPath,
            "d", destinationDirectory,
            className
        };
        try {
            runExec(args, workingDirectory);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
    /**
     * my Theory is that you can kill the process at any time
     * and not bother reading the output with a readline...however
     * this has not been tested.
     * @param args
     * @param workingDirectory
     * @return
     * @throws IOException
     */
    private static Process asynchronousRunExec(final String[] args,
                                               final File workingDirectory) throws IOException {
        final Process[] p = new Process[] { null };
        Thread t = new Thread(new Runnable() {
            public void run() {
                Runtime rt = Runtime.getRuntime();
                try {
                    p[0] = rt.exec(args, null, workingDirectory);
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        });
        t.start();
        return p[0];
    }

    private static void runExec(String[] args,
                                File workingDirectory) throws IOException {
        Runtime rt = Runtime.getRuntime();
        Process p = rt.exec(args, null, workingDirectory);
        BufferedReader br
                = new BufferedReader(new InputStreamReader(p.getErrorStream()));
        String s = null;
        while ((s = br.readLine()) != null)
            System.out.println("dos:" + s);
    }

    public static void rmicTester() {
        String version = "-v1.2";
        String classpath = "c:\\lyon\\j4p\\classes";
        String destination = "c:\\lyon\\j4p\\classes";
        Class clazz = net.rmi.armi.RemoteHelloImplementation.class;
        rmic(version, classpath, destination, clazz);
    }

    public static void rmic(String version,
                            String classpath,
                            String destination,
                            Class clazz) {
        String args[] = {
            version,
            "-classpath", classpath,
            "-d", destination,
            clazz.getName()
        };
        rmic(args);
    }

    public static void rmic(String[] args) {
        sun.rmi.rmic.Main.main(args);
    }

    public static void armic() {
        String cp = ClassPathUtils.getClassPathInUserDir();
        String[] strings = {
            "-v1.2",
            " -d",
            cp,
            "net.rmi.armi.RemoteHelloImplementation"};
        rmic(strings);
    }

    static public void rmic(Class c) {
        String cn = c.getName();
        String cp = ClassPathUtils.getClassPathInUserDir();
        cp = "C:\\lyon\\j4p\\classes";
        String args[] = {
            "-v1.2",
            " -d", "C:\\lyon\\j4p\\classes",
            "net.rmi.armi.RemoteHelloImplementation"
        };
        sun.rmi.rmic.Main.main(args);
    }

    static public void rmic(String fn) {
        String args[] = {fn};
        rmic(args);
    }
}